<?php

namespace Drupal\menu_active_trail_deepest\Menu;

use Drupal\Core\Menu\MenuActiveTrail;

/**
 * Custom MenuActiveTrail that finds the deepest matching menu link.
 */
class MenuActiveTrailDeepest extends MenuActiveTrail {

  /**
   * {@inheritdoc}
   */
  public function getActiveLink($menu_name = NULL) {
    $found = NULL;

    $route_name = $this->routeMatch->getRouteName();
    if ($route_name) {
      $route_parameters = $this->routeMatch->getRawParameters()->all();

      // Load links matching this route.
      $links = $this->menuLinkManager->loadLinksByRoute($route_name, $route_parameters, $menu_name);
      // Select the first matching link.
      if ($links) {
        $found = end($links);
      }
    }
    return $found;
  }

}
